%define shortname comps
%define major 0
%define libname %mklibname %shortname %major
%define libname_devel %mklibname -d %shortname

%bcond_without docs

Name:           libcomps
Version:        0.1.21
Release:        %mkrel 4
Summary:        Comps XML file manipulation library

Group:          System/Libraries
License:        GPLv2+
URL:            https://github.com/rpm-software-management/libcomps
Source0:        https://github.com/rpm-software-management/libcomps/archive/%{version}/%{name}-%{version}.tar.gz
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  pkgconfig(check)
BuildRequires:  pkgconfig(expat)
BuildRequires:  cmake


# prevent provides from nonstandard paths:
%define __provides_exclude_from ^(%{python3_sitearch}/.*\\.so)$

%description
Libcomps is library for structure-like manipulation with content of
comps XML files. Supports read/write XML file, structure(s) modification.

%package -n %{libname}
Summary:        Libraries for %{name}
Group:          System/Libraries
Provides:       %{name} = %{version}-%{release}
Provides:       %{name}%{?_isa} = %{version}-%{release}

%description -n %{libname}
Libraries for %{name}.

%package -n %{libname_devel}
Summary:        Development files for libcomps library
Group:          Development/C
Provides:       %{name}-devel = %{version}-%{release}
Requires:       %{libname}%{?_isa} = %{version}-%{release}

%description -n %{libname_devel}
Development files for %{name}.

%if %{with docs}
%package doc
Summary:        Documentation files for libcomps library
Group:          Development/C
Requires:       %{name}-devel = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  doxygen

%description doc
Documentation files for libcomps library.

%package -n python-libcomps-doc
Summary:        Documentation files for python bindings libcomps library
Group:          Development/Python
Requires:       python3-%{name} = %{version}-%{release}
BuildArch:      noarch
BuildRequires:  python3-sphinx
BuildRequires:  python3-sphinx_rtd_theme

%description -n python-libcomps-doc
Documentation files for python bindings libcomps library.
%endif

%package -n python3-libcomps
Summary:        Python 3 bindings for libcomps library
%{?python_provide:%python_provide python3-libcomps}
Group:          Development/Python
BuildRequires:  python3-devel
Requires:       %{libname}%{?_isa} = %{version}-%{release}

%description -n python3-libcomps
Python3 bindings for libcomps library.


%prep
%autosetup -p1

# Fix build with sphinx 1.8.3
sed -i -e 's,sphinx.ext.pngmath,sphinx.ext.imgmath,' libcomps/src/python/docs/doc-sources/conf.py.in

%build
%cmake %{?with_docs:-DSPHINX_EXECUTABLE="%{_bindir}/sphinx-build-3"} ./libcomps/
%cmake_build
%if %{with docs}
make docs -C %{_vpath_builddir}
make pydocs -C %{_vpath_builddir}
%endif

%check
make test -C %{_vpath_builddir}

%install
%cmake_install

%files -n %{libname}
%doc README.md
%license COPYING
%{_libdir}/libcomps.so.%{major}

%files -n %{libname_devel}
%{_includedir}/*
%{_libdir}/libcomps.so
%{_libdir}/pkgconfig/%{name}.pc

%if %{with docs}
%files doc
%doc build/docs/libcomps-doc/html

%files -n python-libcomps-doc
%doc build/src/python/docs/html
%endif

%files -n python3-libcomps
%{python3_sitearch}/libcomps
%{python3_sitearch}/%{name}-%{version}-py%{python3_version}.egg-info


%changelog
* Mon Jul 07 2025 umeabot <umeabot> 0.1.21-4.mga10
+ Revision: 2248288
- Mageia 10 Mass Rebuild

* Sun Mar 16 2025 wally <wally> 0.1.21-3.mga10
+ Revision: 2164886
- rebuild for libxml2 2.13.6

* Sat Feb 22 2025 wally <wally> 0.1.21-2.mga10
+ Revision: 2150882
- rebuild for python3.13

* Sat Apr 13 2024 wally <wally> 0.1.21-1.mga10
+ Revision: 2056750
- new version 0.1.21
- drop old obsoletes

* Thu Dec 07 2023 wally <wally> 0.1.18-4.mga10
+ Revision: 2015200
- rebuild for py3.12
- add libcomps provides to lib pkg
- add bcond for building docs

* Sat Apr 02 2022 umeabot <umeabot> 0.1.18-3.mga9
+ Revision: 1840576
- Mageia 9 Mass Rebuild

* Sun Feb 06 2022 wally <wally> 0.1.18-2.mga9
+ Revision: 1772307
- rebuild for python3.10

* Sun Sep 26 2021 luigiwalser <luigiwalser> 0.1.18-1.mga9
+ Revision: 1746475
- 0.1.18

* Fri Aug 06 2021 luigiwalser <luigiwalser> 0.1.17-1.mga9
+ Revision: 1739950
- 0.1.17
- update source URL

* Mon Mar 15 2021 wally <wally> 0.1.15-3.mga9
+ Revision: 1703528
- rebuild for python 3.9

* Thu Aug 20 2020 joequant <joequant> 0.1.15-2.mga8
+ Revision: 1616840
- fix cmake

* Tue Jul 07 2020 ngompa <ngompa> 0.1.15-1.mga8
+ Revision: 1602713
- Update to 0.1.15

* Tue Feb 18 2020 umeabot <umeabot> 0.1.14-2.mga8
+ Revision: 1539459
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sun Dec 08 2019 ngompa <ngompa> 0.1.14-1.mga8
+ Revision: 1465065
- Update to 0.1.14
- Drop all patches part of this release

* Sun Sep 08 2019 wally <wally> 0.1.11-2.mga8
+ Revision: 1438353
- add patches from upstream to fix build
- rebuild for python3.8

* Sun Mar 31 2019 ngompa <ngompa> 0.1.11-1.mga7
+ Revision: 1383708
- Update to 0.1.11
- Drop upstreamed patches
- Drop Python 2 subpackage

* Sun Jan 06 2019 ngompa <ngompa> 0.1.9-1.mga7
+ Revision: 1350211
- Update to 0.1.9

* Sat Jan 05 2019 wally <wally> 0.1.8-5.mga7
+ Revision: 1349791
- rebuild for python3.7
- fix pydoc build with sphinx 1.8.3 (pngmath is obsoleted)

* Sun Sep 23 2018 umeabot <umeabot> 0.1.8-4.mga7
+ Revision: 1298790
- Mageia 7 Mass Rebuild

* Fri Aug 04 2017 tv <tv> 0.1.8-3.mga7
+ Revision: 1134674
- rebuild for new python

* Sun Nov 27 2016 ngompa <ngompa> 0.1.8-2.mga6
+ Revision: 1070468
- Bump for rebuilding against core/release

* Sat Nov 26 2016 ngompa <ngompa> 0.1.8-1.mga6
+ Revision: 1070199
- Upgrade to 0.1.8

* Mon Feb 15 2016 umeabot <umeabot> 0.1.7-5.mga6
+ Revision: 960934
- Mageia 6 Mass Rebuild

* Wed Oct 14 2015 shlomif <shlomif> 0.1.7-4.mga6
+ Revision: 891198
- Fix requires on 32-bit systems (Thanks to Neal Gompa)

* Thu Oct 08 2015 tv <tv> 0.1.7-3.mga6
+ Revision: 887753
- BR python3-sphinx_rtd_theme
- rebuild for python 3.5
+ shlomif <shlomif>
- Cleanups for the .spec by Neal Gompa

* Sun Oct 04 2015 shlomif <shlomif> 0.1.7-2.mga6
+ Revision: 886222
- Fix Requires - patch thanks to Neal Gompa
- Importing libcomps - thanks to Neal Gompa/Son_Goku


* Fri Sep 25 2015 Neal Gompa <ngompa13{%%}gmail{*}com> - 0.1.7-2
- Initial port to Mageia

* Thu Jul 02 2015 Jindrich Luza <jluza@redhat.com> 0.1.7
- added langpacks to union process
- comps DOCTYPE read-write-read fix
- support biarchonly attribute
- fixed rhbz#1073885 rhbz#1073890 rhbz#1073907 rhbz#1073979
- fix rhbz#1073079
- comps_*_match() now support fnmatching
- added libpycomps.MATCH_IGNORECASE as matching flag
- added group.packages_match
- added comps.groups_match, comps.categories_match, comps.entironments_match
- PyCOMPS_Package hash
- cmake-2.6, python-2.6, RHEL-6 compatible
- '_arch' attribute change to 'arch'
- empty 'arch' attribute will be ommited from output from now

* Wed Jan 29 2014 Jindrich Luza <jluza@redhat.com> 0.1.6
- version bumped
- added libcomps.MDict.keys()
-         libcomps.MDict.values()
-         libcomps.MDict.items()
-         libcomps.MDict.clear()
-         libcomps.MDict.update()
-         libcomps.MDict.copy()
- COMPS_List replaced with COMPS_HSList
- added missing basearchonly to DocGroupPackage
- python3/CMakeLists.txt fixed
- added explicit attributes support for xml options
- added arch_filter test for python
- insert method in libcomps.Sequence
- Unioning is now accomplished with replace x append policy
- Weaker package equality check (comparing only name now)
- Fixed leeks in unioning
- modified test_merge_comps test_libcomps
- dictionaries are now storing keys in alphabetical order
- comps parser redesigned
- change python/tests directory composition
- added elem attributes check in parser
- xml output '_arch' attribute support
- parser and xml output defaults options for specify defaults values
- comps object validation in python
- added validity checker before append/set object to list (python only)
- .validate() method
- added libcomps.Dict.keys
-         libcomps.Dict.values
-         libcomps.Dict.items
-         libcomps.Dict.clear
-         libcomps.Dict.update
-         libcomps.Dict.copy
- added xml output options (comps.xml_str([options = {}]), comps.xml_f(options = {}))

* Wed Oct 23 2013 Jindrich Luza <jluza@redhat.com> 0.1.4-4
- group.uservisible is true by default now.
- fixed comps_mobjradix parent node problem
- implemented bindings for blacklist, whiteout and langpacks
- COMPS_Logger redesigned

* Tue Oct 08 2013 Jindrich Luza <jluza@redhat.com> 0.1.5
- version bump
- PyCOMPS_Sequence.__getitem__["objectid"] implemented for libcomps.GroupList, libcomps.CategoryList, libcomps.EnvList
- added missing files
- missing display_order fix for libcomps.Environment

* Tue Oct 01 2013 Jindrich Luza <jluza@redhat.com> 0.1.4
- added missing files
- architectural redesign finished
- fixed #1003986 by Gustavo Luiz Duarte guidelines (but not tested on ppc)
- fixed bug #1000449
- fixed bug #1000442
- added GroupId.default test
- some minor unreported bugs discovered during testing fixed
- finished default attribute support in groupid object
- Comps.get_last_parse_errors and Comps.get_last_parse_log has been renamed
-   as Comps.get_last_errors and Comps.get_last_log
- version bumped. Python bindings is now easier.
- added missing files

* Tue Aug 20 2013 Jindrich Luza <jluza@redhat.com> 0.1.3
- finished default attribute support in groupid object
- Comps.get_last_parse_errors and Comps.get_last_parse_log has been renamed
-   as Comps.get_last_errors and Comps.get_last_log
- finished default attribute support in groupid object
- Comps.get_last_parse_errors and Comps.get_last_parse_log has been renamed
-   as Comps.get_last_errors and Comps.get_last_log

* Thu Jul 18 2013 Jindrich Luza <jluza@redhat.com> 0.1.2
- automatic changelog system
- fixed issue #14
- libcomps.Dict is now behave more like python dict. Implemented iter(libcomps.Dict)
- libcomps.iteritems() and libcomps.itervalues()
- remaked error reporting system.
-     libcomps.Comps.fromxml_f and libcomps.Comps.fromxml_str now return
-     -1, 0 or 1. 0 means parse procedure completed without any problem,
-     1 means there's some errors or warnings but not fatal. -1 indicates
-     fatal error problem (some results maybe given, but probably incomplete
-     and invalid)
- errors catched during parsing can be obtained by calling
-     libcomps.Comps.get_last_parse_errors
- all log is given by
-     libcomps.Comps.get_last_parse_log
- prop system complete
- fixed issue 1
- fixed issue 3
- added <packagereq requires=...> support
- new prop system in progress....
- separated doc package
- some minor fixes in CMakeFiles
- improved integrated tests

* Tue Jun 25 2013 Jindrich Luza <jluza@redhat.com> 0.1.1-1
- Automatic commit of package [libcomps] release [0.1.1-1].

